<?xml version="1.0" encoding="UTF-8"?>
<api xmlns="http://ws.apache.org/ns/synapse" name="Books" context="/books">
   <resource methods="GET"
             uri-template="/publicBooks?filter={uri.var.filter}&amp;limit={uri.var.limit}&amp;offset={uri.var.offset}">
      <inSequence>
         <property name="uri.var.filter"
                   expression="$url:filter"
                   scope="default"
                   type="STRING"/>
         <property name="uri.var.limit"
                   expression="$url:limit"
                   scope="default"
                   type="STRING"/>
         <property name="uri.var.offset"
                   expression="$url:offset"
                   scope="default"
                   type="STRING"/>
         <filter source="boolean(get-property('uri.var.filter'))" regex="false">
            <then>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8080/publicBooks?limit={uri.var.limit}&amp;offset={uri.var.offset}"/>
                  </endpoint>
               </call>
            </then>
            <else>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8080/filterPublicBooks?filter={uri.var.filter}&amp;limit={uri.var.limit}&amp;offset={uri.var.offset}"/>
                  </endpoint>
               </call>
            </else>
         </filter>
         <property name="messageType" value="application/xml" scope="axis2"/>
         <property name="countRequests"
                   expression="count(//jsonObject/books)"
                   scope="default"
                   type="STRING"
                   description="countRequests"/>
         <iterate id="iterate over books" expression="//jsonObject/books">
            <target>
               <sequence>
                  <property name="uri.var.id"
                            expression="//id"
                            scope="default"
                            type="STRING"/>
                  <property name="title" expression="//title" scope="default" type="STRING"/>
                  <property name="autor" expression="//autor" scope="default" type="STRING"/>
                  <property name="price" expression="//price" scope="default" type="STRING"/>
                  <property name="published"
                            expression="//published"
                            scope="default"
                            type="INTEGER"/>
                  <property name="userName"
                            expression="//userName"
                            scope="default"
                            type="STRING"/>
                  <property name="fileUri"
                            expression="//fileUri"
                            scope="default"
                            type="STRING"/>
                  <property name="description"
                            expression="//description"
                            scope="default"
                            type="STRING"/>
                  <log level="custom">
                     <property name="fileUri" expression="get-property('fileUri')"/>
                  </log>
                  <call>
                     <endpoint>
                        <http method="GET"
                              uri-template="http://localhost:8090/image/book?id={uri.var.id}"/>
                     </endpoint>
                  </call>
                  <filter source="get-property('axis2', 'HTTP_SC')" regex="200">
                     <then>
                        <filter source="boolean(get-property('fileUri'))" regex="true">
                           <then>
                              <payloadFactory media-type="json">
                                 <format> {      
								 "id":$1,    
								 "title":"$2", 
								 "autor":"$3", 
								 "price":$4,  
								 "published":$5,
								 "userName":"$6", 
								 "fileUri":"$7",
								 "description":"$8", 
								 "img": {       
								 "id":"$9",    
								 "name":"$10",   
								 "type":"$11",    
								 "bytes":"$12"       
								 }             
								 }                </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('fileUri')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                    <arg evaluator="json" expression="$.id"/>
                                    <arg evaluator="json" expression="$.name"/>
                                    <arg evaluator="json" expression="$.type"/>
                                    <arg evaluator="json" expression="$.bytes"/>
                                 </args>
                              </payloadFactory>
                              <log level="custom">
                                 <property name="BOOK" expression="json-eval($.)"/>
                              </log>
                           </then>
                           <else>
                              <payloadFactory media-type="json">
                                 <format> {         
								 "id":$1,       
								 "title":"$2",  
								 "autor":"$3",  
								 "price":$4,   
								 "published":$5,    
								 "userName":"$6",   
								 "fileUri":"",    
								 "description":"$7",    
								 "img": {         "id": "$8",         "name":"$9",         "type":"$10",         "bytes":"$11"           }                   }           </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                    <arg evaluator="json" expression="$.id"/>
                                    <arg evaluator="json" expression="$.name"/>
                                    <arg evaluator="json" expression="$.type"/>
                                    <arg evaluator="json" expression="$.bytes"/>
                                 </args>
                              </payloadFactory>
                           </else>
                        </filter>
                     </then>
                     <else>
                        <filter source="boolean(get-property('fileUri'))" regex="true">
                           <then>
                              <payloadFactory media-type="json">
                                 <format> {            "id":$1,         "title":"$2",         "autor": "$3",         "price": $4,         "published": $5,         "userName": "$6",         "fileUri": "$7",         "description":"$8",         "img":{                  "id":"",          "bytes":"",           "name":"",         "type":""         }                     }                                                            </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('fileUri')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                 </args>
                              </payloadFactory>
                           </then>
                           <else>
                              <payloadFactory media-type="json">
                                 <format> {          "id":$1,         "title":"$2",         "autor":"$3",         "price":$4,         "published":"$5",         "userName":"$6",         "fileUri":"",         "description":"$7",         "img":{           "id":"",         "bytes":"",         "name":"",         "type":""          }                  }                                                            </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                 </args>
                              </payloadFactory>
                           </else>
                        </filter>
                     </else>
                  </filter>
               </sequence>
            </target>
         </iterate>
         <property name="Aggregate_Response" scope="default">
            <jsonObject/>
         </property>
         <aggregate>
            <completeCondition>
               <messageCount min="{get-property('countRequests')}"
                             max="{get-property('countRequests')}"/>
            </completeCondition>
            <onComplete expression="//jsonObject" enclosingElementProperty="Aggregate_Response">
               <property name="messageType" value="application/json" scope="axis2"/>
               <property name="HTTP_SC" value="200" scope="axis2" type="STRING"/>
               <respond/>
            </onComplete>
         </aggregate>
         <respond/>
      </inSequence>
      <outSequence/>
      <faultSequence>
         <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
         <payloadFactory media-type="json">
            <format>      {                                 "code": 500,                           "message":"Internal server error" ,                           "description":"Internal server error"                                                             }                               </format>
            <args/>
         </payloadFactory>
         <respond/>
      </faultSequence>
   </resource>
   <resource methods="GET"
             uri-template="/privateBooks?user={uri.var.user}&amp;filter={uri.var.filter}&amp;limit={uri.var.limit}&amp;offset={uri.var.offset}">
      <inSequence>
         <property name="uri.var.filter"
                   expression="$url:filter"
                   scope="default"
                   type="STRING"/>
         <property name="uri.var.limit"
                   expression="$url:limit"
                   scope="default"
                   type="STRING"/>
         <property name="uri.var.offset"
                   expression="$url:offset"
                   scope="default"
                   type="STRING"/>
         <property name="uri.var.user"
                   expression="$url:user"
                   scope="default"
                   type="STRING"/>
         <filter source="boolean(get-property('uri.var.filter'))" regex="false">
            <then>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8080/userBooks?user={uri.var.user}&amp;limit={uri.var.limit}&amp;offset={uri.var.offset}"/>
                  </endpoint>
               </call>
            </then>
            <else>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8080/filterUserBooks?user={uri.var.user}&amp;filter={uri.var.filter}&amp;limit={uri.var.limit}&amp;offset={uri.var.offset}"/>
                  </endpoint>
               </call>
            </else>
         </filter>
         <property name="messageType" value="application/xml" scope="axis2"/>
         <property name="countRequests"
                   expression="count(//jsonObject/books)"
                   scope="default"
                   type="STRING"
                   description="countRequests"/>
         <iterate id="iterate over books" expression="//jsonObject/books">
            <target>
               <sequence>
                  <property name="uri.var.id"
                            expression="//id"
                            scope="default"
                            type="STRING"/>
                  <property name="title" expression="//title" scope="default" type="STRING"/>
                  <property name="autor" expression="//autor" scope="default" type="STRING"/>
                  <property name="price" expression="//price" scope="default" type="STRING"/>
                  <property name="published"
                            expression="//published"
                            scope="default"
                            type="INTEGER"/>
                  <property name="userName"
                            expression="//userName"
                            scope="default"
                            type="STRING"/>
                  <property name="fileUri"
                            expression="//fileUri"
                            scope="default"
                            type="STRING"/>
                  <property name="description"
                            expression="//description"
                            scope="default"
                            type="STRING"/>
                  <call>
                     <endpoint>
                        <http method="GET"
                              uri-template="http://localhost:8090/image/book?id={uri.var.id}"/>
                     </endpoint>
                  </call>
                  <filter source="get-property('axis2', 'HTTP_SC')" regex="200">
                     <then>
                        <filter source="boolean(get-property('fileUri'))" regex="true">
                           <then>
                              <payloadFactory media-type="json">
                                 <format> {                         "id":$1,                                       "title": "$2",                                                           "autor": "$3",                                                                             "price": $4,                                                                            "published": $5,                                                                           "userName": "$6",                                                                           "fileUri":"$7",                                                                                    "description":"$8",             "img": {                "id": "$9",           "name":"$10",                 "type":"$11",          "bytes":"$12"            }              }               </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('fileUri')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                    <arg evaluator="json" expression="$.id"/>
                                    <arg evaluator="json" expression="$.name"/>
                                    <arg evaluator="json" expression="$.type"/>
                                    <arg evaluator="json" expression="$.bytes"/>
                                 </args>
                              </payloadFactory>
                           </then>
                           <else>
                              <payloadFactory media-type="json">
                                 <format> {                         "id":$1,                                       "title": "$2",                                                           "autor": "$3",                                                                             "price": $4,                                                                            "published": $5,                                                                           "userName": "$6",                                                                           "fileUri": "",                                                                                    "description":"$7",             "img": {                "id": "$8",           "name":"$9",                 "type":"$10",          "bytes":"$11"            }              }               </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                    <arg evaluator="json" expression="$.id"/>
                                    <arg evaluator="json" expression="$.name"/>
                                    <arg evaluator="json" expression="$.type"/>
                                    <arg evaluator="json" expression="$.bytes"/>
                                 </args>
                              </payloadFactory>
                           </else>
                        </filter>
                     </then>
                     <else>
                        <filter source="boolean(get-property('fileUri'))" regex="true">
                           <then>
                              <payloadFactory media-type="json">
                                 <format> {                                                                     "id":$1,                                                                              "title": "$2",                                                                  "autor": "$3",                                                                      "price": $4,                                                                       "published": $5,                                                                      "userName": "$6",                                                                                 "fileUri":"$7",                                                                                 "description":"$8",             "img":{                         "id":"",                     "bytes":"",               "name":"",              "type":""                 }                    }                                                            </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('fileUri')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                 </args>
                              </payloadFactory>
                           </then>
                           <else>
                              <payloadFactory media-type="json">
                                 <format> {                            "id":$1,                  "title": "$2",              "autor": "$3",               "price": $4,                "published": "$5",              "userName": "$6",             "fileUri":"",               "description":"$7",                "img":{                         "id":"",             "bytes":"",           "name":"",            "type":""             }                      }                                                            </format>
                                 <args>
                                    <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                                    <arg evaluator="xml" expression="get-property('title')"/>
                                    <arg evaluator="xml" expression="get-property('autor')"/>
                                    <arg evaluator="xml" expression="get-property('price')"/>
                                    <arg evaluator="xml" expression="get-property('published')"/>
                                    <arg evaluator="xml" expression="get-property('userName')"/>
                                    <arg evaluator="xml" expression="get-property('description')"/>
                                 </args>
                              </payloadFactory>
                           </else>
                        </filter>
                     </else>
                  </filter>
               </sequence>
            </target>
         </iterate>
         <property name="Aggregate_Response" scope="default">
            <jsonObject/>
         </property>
         <aggregate>
            <completeCondition>
               <messageCount min="{get-property('countRequests')}"
                             max="{get-property('countRequests')}"/>
            </completeCondition>
            <onComplete expression="//jsonObject" enclosingElementProperty="Aggregate_Response">
               <property name="messageType" value="application/json" scope="axis2"/>
               <property name="HTTP_SC" value="200" scope="axis2" type="STRING"/>
               <respond/>
            </onComplete>
         </aggregate>
         <respond/>
      </inSequence>
      <outSequence/>
      <faultSequence>
         <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
         <payloadFactory media-type="json">
            <format>      {                                               "code": 500,                                             "message":"Internal server error" ,                           "description":"Internal server error"                                                             }                               </format>
            <args/>
         </payloadFactory>
         <respond/>
      </faultSequence>
   </resource>
   <resource methods="GET" uri-template="/details?id={uri.var.id}">
      <inSequence>
         <property name="uri.var.id" expression="$url:id" scope="default"/>
         <call>
            <endpoint>
               <http method="GET" uri-template="http://localhost:8080/books?id={uri.var.id}"/>
            </endpoint>
         </call>
         <filter source="get-property('axis2', 'HTTP_SC')" regex="200">
            <then>
               <property name="uri.var.id"
                         expression="json-eval($.id)"
                         scope="default"
                         type="STRING"/>
               <property name="title"
                         expression="json-eval($.title)"
                         scope="default"
                         type="STRING"/>
               <property name="autor"
                         expression="json-eval($.autor)"
                         scope="default"
                         type="STRING"/>
               <property name="price"
                         expression="json-eval($.price)"
                         scope="default"
                         type="STRING"/>
               <property name="published"
                         expression="json-eval($.published)"
                         scope="default"
                         type="INTEGER"/>
               <property name="userName"
                         expression="json-eval($.userName)"
                         scope="default"
                         type="STRING"/>
               <property name="fileUri"
                         expression="json-eval($.fileUri)"
                         scope="default"
                         type="STRING"/>
               <property name="description"
                         expression="json-eval($.description)"
                         scope="default"
                         type="STRING"/>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8090/image/book?id={uri.var.id}"/>
                  </endpoint>
               </call>
               <filter source="get-property('axis2', 'HTTP_SC')" regex="200">
                  <then>
                     <payloadFactory media-type="json">
                        <format> {                                          "id":$1,                               "title": "$2",                                    "autor": "$3",                               "price": $4,                              "published": $5,                               "userName": "$6",                              "fileUri":"$7",                               "description": "$8",                                  "img": {                                          "id": $9,                                         "name":"$10",                                           "type":"$11",                                         "bytes":"$12"                                       }                              }                             </format>
                        <args>
                           <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                           <arg evaluator="xml" expression="get-property('title')"/>
                           <arg evaluator="xml" expression="get-property('autor')"/>
                           <arg evaluator="xml" expression="get-property('price')"/>
                           <arg evaluator="xml" expression="get-property('published')"/>
                           <arg evaluator="xml" expression="get-property('userName')"/>
                           <arg evaluator="xml" expression="get-property('fileUri')"/>
                           <arg evaluator="xml" expression="get-property('description')"/>
                           <arg evaluator="json" expression="$.id"/>
                           <arg evaluator="json" expression="$.name"/>
                           <arg evaluator="json" expression="$.type"/>
                           <arg evaluator="json" expression="$.bytes"/>
                        </args>
                     </payloadFactory>
                  </then>
                  <else>
                     <payloadFactory media-type="json">
                        <format> {           "id":$1,                                               "title": "$2",                                               "autor": "$3",                                               "price": $4,                                                "published": "$5",                                                 "userName": "$6",                                                   "fileUri":"$7",                                               "description":"$8",                                                "img":{                                                                  "id":0,                                                          "bytes":"",                                                        "name":"",                                                        "type":""                                                            }                                                        }                         </format>
                        <args>
                           <arg evaluator="xml" expression="get-property('uri.var.id')"/>
                           <arg evaluator="xml" expression="get-property('title')"/>
                           <arg evaluator="xml" expression="get-property('autor')"/>
                           <arg evaluator="xml" expression="get-property('price')"/>
                           <arg evaluator="xml" expression="get-property('published')"/>
                           <arg evaluator="xml" expression="get-property('userName')"/>
                           <arg evaluator="xml" expression="get-property('fileUri')"/>
                           <arg evaluator="xml" expression="get-property('description')"/>
                        </args>
                     </payloadFactory>
                     <property name="HTTP_SC" value="200" scope="axis2" type="STRING"/>
                     <respond/>
                  </else>
               </filter>
            </then>
            <else>
               <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
               <payloadFactory media-type="json">
                  <format>      {                                 "code": 500,                           "message":"Internal server error" ,                           "description":"Book endpoint not found"                                                             }                               </format>
                  <args/>
               </payloadFactory>
               <send/>
            </else>
         </filter>
      </inSequence>
      <outSequence/>
      <faultSequence>
         <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
         <payloadFactory media-type="json">
            <format>      {                    "code": 500,                       "message":"Internal server error" ,                     "description":"Internal server error"                   }                               </format>
            <args/>
         </payloadFactory>
         <send/>
      </faultSequence>
   </resource>
   <resource methods="GET" uri-template="/countPublicBooks?filter={uri.var.filter}">
      <inSequence>
         <property name="uri.var.filter" expression="$url:filter" scope="default"/>
         <filter source="boolean(get-property('uri.var.filter'))" regex="false">
            <then>
               <call>
                  <endpoint>
                     <http method="GET" uri-template="http://localhost:8080/totalPublicBooks"/>
                  </endpoint>
               </call>
            </then>
            <else>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8080/countPublicBooks?filter={uri.var.filter}"/>
                  </endpoint>
               </call>
            </else>
         </filter>
         <filter source="get-property('axis2', 'HTTP_SC')" regex="200">
            <then>
               <payloadFactory media-type="json">
                  <format>      {             "value": $1        }                     </format>
                  <args>
                     <arg evaluator="json" expression="$.count"/>
                  </args>
               </payloadFactory>
               <respond/>
            </then>
            <else>
               <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
               <payloadFactory media-type="json">
                  <format>      {             "code": 500,                        "message":"Internal server error" ,                        "description":"Book endpoint not found"          }                     </format>
                  <args/>
               </payloadFactory>
               <respond/>
            </else>
         </filter>
      </inSequence>
      <outSequence/>
      <faultSequence>
         <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
         <payloadFactory media-type="json">
            <format>      {                    "code": 500,                       "message":"Internal server error" ,                     "description":"Internal server error"                   }                               </format>
            <args/>
         </payloadFactory>
         <send/>
      </faultSequence>
   </resource>
   <resource methods="GET"
             uri-template="/countPrivateBooks?user={uri.var.user}&amp;filter={uri.var.filter}">
      <inSequence>
         <property name="uri.var.user" expression="$url:user" scope="default"/>
         <property name="uri.var.filter" expression="$url:filter" scope="default"/>
         <filter source="boolean(get-property('uri.var.filter'))" regex="false">
            <then>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8080/totalUserBooks?user={uri.var.user}"/>
                  </endpoint>
               </call>
            </then>
            <else>
               <call>
                  <endpoint>
                     <http method="GET"
                           uri-template="http://localhost:8080/countUserBooks?user={uri.var.user}&amp;filter={uri.var.filter}"/>
                  </endpoint>
               </call>
            </else>
         </filter>
         <filter source="get-property('axis2', 'HTTP_SC')" regex="200">
            <then>
               <payloadFactory media-type="json">
                  <format>      {             "value": $1        }                     </format>
                  <args>
                     <arg evaluator="json" expression="$.count"/>
                  </args>
               </payloadFactory>
               <respond/>
            </then>
            <else>
               <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
               <payloadFactory media-type="json">
                  <format>      {             "code": 500,                        "message":"Internal server error" ,                        "description":"Book endpoint not found"          }                     </format>
                  <args/>
               </payloadFactory>
               <respond/>
            </else>
         </filter>
      </inSequence>
      <outSequence/>
      <faultSequence>
         <property name="HTTP_SC" value="500" scope="axis2" type="STRING"/>
         <payloadFactory media-type="json">
            <format>      {                    "code": 500,                       "message":"Internal server error" ,                     "description":"Internal server error"                   }                               </format>
            <args/>
         </payloadFactory>
         <send/>
      </faultSequence>
   </resource>
</api>
